/**
 * This file is a part of DesQ SNI.
 * DesQ SNI is a Widget to show SN Icons for DesQ Shell.
 * Copyright 2019-2022 Britanicus <marcusbritanicus@gmail.com>
 *
 * This file was originally taken from LXQt project
 * <https://github.com/lxqt/lxqt-panel>
 * Several modifications have been made to suit the needs of DesQ
 * Any and all bug reports are to be filed with DesQ and not LXQt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option, any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 **/

#include "SNIInterface.hpp"

StatusNotifierItem::StatusNotifierItem( QString serv, QString path, QDBusConnection conn, QObject *parent ) :
    QDBusAbstractInterface( serv, path, staticInterfaceName(), conn, parent ) {
}


StatusNotifierItem::~StatusNotifierItem() {
}


QString StatusNotifierItem::attentionIconName() const {
    return qvariant_cast<QString>( property( "AttentionIconName" ) );
}


IconPixmapList StatusNotifierItem::attentionIconPixmap() const {
    return qvariant_cast<IconPixmapList>( property( "AttentionIconPixmap" ) );
}


QString StatusNotifierItem::attentionMovieName() const {
    return qvariant_cast<QString>( property( "AttentionMovieName" ) );
}


QString StatusNotifierItem::category() const {
    return qvariant_cast<QString>( property( "Category" ) );
}


QString StatusNotifierItem::iconName() const {
    return qvariant_cast<QString>( property( "IconName" ) );
}


IconPixmapList StatusNotifierItem::iconPixmap() const {
    return qvariant_cast<IconPixmapList>( property( "IconPixmap" ) );
}


QString StatusNotifierItem::iconThemePath() const {
    return qvariant_cast<QString>( property( "IconThemePath" ) );
}


QString StatusNotifierItem::id() const {
    return qvariant_cast<QString>( property( "Id" ) );
}


bool StatusNotifierItem::itemIsMenu() const {
    return qvariant_cast<bool>( property( "ItemIsMenu" ) );
}


QDBusObjectPath StatusNotifierItem::menu() const {
    return qvariant_cast<QDBusObjectPath>( property( "Menu" ) );
}


QString StatusNotifierItem::overlayIconName() const {
    return qvariant_cast<QString>( property( "OverlayIconName" ) );
}


IconPixmapList StatusNotifierItem::overlayIconPixmap() const {
    return qvariant_cast<IconPixmapList>( property( "OverlayIconPixmap" ) );
}


QString StatusNotifierItem::status() const {
    return qvariant_cast<QString>( property( "Status" ) );
}


QString StatusNotifierItem::title() const {
    return qvariant_cast<QString>( property( "Title" ) );
}


ToolTip StatusNotifierItem::toolTip() const {
    return qvariant_cast<ToolTip>( property( "ToolTip" ) );
}


int StatusNotifierItem::windowId() const {
    return qvariant_cast<int>( property( "WindowId" ) );
}


QDBusPendingReply<> StatusNotifierItem::Activate( int x, int y ) {
    QList<QVariant> argumentList;

    argumentList << QVariant::fromValue( x ) << QVariant::fromValue( y );
    return asyncCallWithArgumentList( QLatin1String( "Activate" ), argumentList );
}


QDBusPendingReply<> StatusNotifierItem::ContextMenu( int x, int y ) {
    QList<QVariant> argumentList;

    argumentList << QVariant::fromValue( x ) << QVariant::fromValue( y );
    return asyncCallWithArgumentList( QLatin1String( "ContextMenu" ), argumentList );
}


QDBusPendingReply<> StatusNotifierItem::Scroll( int delta, const QString& orientation ) {
    QList<QVariant> argumentList;

    argumentList << QVariant::fromValue( delta ) << QVariant::fromValue( orientation );
    return asyncCallWithArgumentList( QLatin1String( "Scroll" ), argumentList );
}


QDBusPendingReply<> StatusNotifierItem::SecondaryActivate( int x, int y ) {
    QList<QVariant> argumentList;

    argumentList << QVariant::fromValue( x ) << QVariant::fromValue( y );
    return asyncCallWithArgumentList( QLatin1String( "SecondaryActivate" ), argumentList );
}
